////////////////////////////////////////////////////////////////////
// RPUq^V~[V
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <direct.h>
#include <stdlib.h>
#include "Vector3.h"
#include "RK4_Nbody.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
double dt = 0.001;
//d͉x
double g = 10.0;
//Ђ̒
double L = 1.0;

//d͉xxNg
Vector3 vec_g = Vector3(0, 0, -g);
//
double m_box = 10.0;
double m = 1.0;
//x
double v1 = 0.0;
double v2 = sqrt(40.0);
//ŮpU
double omega_box = sqrt(g / L);
//U̐U
double l = 0.5;


//x_̉xxNg
Vector3 a_box_function(double t) {
	//return Vector3(0, 0, 0);
	return Vector3( 10.0 * sin(omega_box * t), 0, 0);

};
//zPʃxNg
Vector3 z_hat(0, 0, 1);


////////////////////////////////////////////////////////////////////
// lvZp[^
////////////////////////////////////////////////////////////////////
//xxNgiK{j
void RK4_Nbody::A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as) {
	for (int i = 0; i < N; i++) {
		out_as[i].set(0, 0, 0);
	}

	Vector3 a_box = a_box_function(t);

	//xNg
	Vector3 vec_L = rs[1]- rs[0];
	//Αx
	Vector3 v_ij = vs[1] - vs[0];

	Vector3 vec_S = vec_L / (pow(vec_L.dot(z_hat), 2)/ m_box - (m + m_box) / (m * m_box) * vec_L.lengthSq()) *
		(v_ij.lengthSq() + vec_g.dot(vec_L) - a_box.dot(vec_L));

	double Sz = vec_S.dot(z_hat);

	//Ԃ։x
	out_as[0] = a_box - vec_S / m_box + Sz * z_hat / m_box;
	//Uq։x
	out_as[1] = vec_g + vec_S / m;

};
////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
	//tH_̐
	_mkdir("output");

	std::ostringstream data1;
	std::ostringstream data2;

	//QNb^IuWFNg̐
	RK4_Nbody rk4_Nbody(2, dt);
	//ʒuxNgƑxxNg
	rk4_Nbody.rs[0].set(0, 0, 0);
	rk4_Nbody.vs[0].set(0, 0, 0);
	rk4_Nbody.rs[1].set(0, 0, - L);
	rk4_Nbody.vs[1].set(v2, 0, 0);

	int M = round((t_max - t_min) / dt);
	for (int i = 0; i <= M; i++) {
		double t = i * dt;
		//ofs << t << " " << rk4_Nbody.rs[0].x << " " << rk4_Nbody.rs[0].y << " " << rk4_Nbody.rs[0].z << " " << rk4_Nbody.rs[1].x << " " << rk4_Nbody.rs[1].y << " " << rk4_Nbody.rs[1].z << std::endl;
		if (i % 10 == 0) data1 << rk4_Nbody.rs[0].x << " " << rk4_Nbody.rs[0].z << std::endl;
		if (i % 10 == 0) data2 << rk4_Nbody.rs[1].x << " " << rk4_Nbody.rs[1].z << std::endl;

		//QENb^@ɂ鎞ԔW
		rk4_Nbody.timeEvolution(t);

		for (int n = 0; n < 2; n++) {
			//ʒu̍XV
			rk4_Nbody.rs[n] = rk4_Nbody.rs[n] + rk4_Nbody.drs[n];
			//x̍XV
			rk4_Nbody.vs[n] = rk4_Nbody.vs[n] + rk4_Nbody.dvs[n];
		}

	}

	double E1 = 1.0 / 2.0 * m_box * rk4_Nbody.vs[0].lengthSq() + m_box * g * rk4_Nbody.rs[0].z;
	double E2 = 1.0 / 2.0 * m * rk4_Nbody.vs[1].lengthSq() + m * g * rk4_Nbody.rs[1].z;

	double _L01 = Vector3::distance(rk4_Nbody.rs[1], rk4_Nbody.rs[0]);
	std::cout << "L=" << (_L01 - L) << " E=" << E1 + E2 << std::endl;


	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/HorizontalFreePendulum.txt";
	// t@Co̓Xg[̏
	std::ofstream ofs(filename.str());

	ofs << "#x:xW" << std::endl;
	ofs << "#y:zW" << std::endl;
	ofs << "#legend:  " << std::endl;
	ofs << "#showLines: false false true true false false" << std::endl;
	ofs << "#showMarkers: true true false false true true" << std::endl;
	ofs << "#fills: false false false false" << std::endl;

	ofs << "#dataset:1 " << std::endl;
	ofs << data1.str() << std::endl;
	ofs << "" << std::endl;
	ofs << "#dataset:2 " << std::endl;
	ofs << data2.str() << std::endl;

	ofs.close();

	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;

}

/*
gccRpC
g++ -c Vector3.cpp -std=c++14 -O2
g++ -c RK4_Nbody.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Vector3.o RK4_Nbody.o
*/
